<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		polls
 */

class Block_main_poll
{

	/**
	 * Standard modular info function.
	 *
	 * @return ?array	Map of module info (NULL: module is disabled).
	 */
	function info()
	{
		$info=array();
		$info['author']='Chris Graham';
		$info['organisation']='ocProducts';
		$info['hacked_by']=NULL;
		$info['hack_version']=NULL;
		$info['version']=2;
		$info['locked']=false;
		$info['parameters']=array('param','zone');
		return $info;
	}

	/**
	 * Standard modular run function.
	 *
	 * @param  array		A map of parameters.
	 * @return tempcode	The result of execution.
	 */
	function run($map)
	{
		$param=array_key_exists('param',$map)?intval($map['param']):-1;
		if ($param==-1) $param=get_param_integer('poll_id',$param);
		$zone=array_key_exists('zone',$map)?$map['zone']:get_module_zone('polls');

		require_css('polls');
		require_lang('polls');

		if (get_value('no_frames')!=='0') // You have to explicitly set no_frames to 0 if you want frames here, as it makes styling a PITA and slows loading -- not worth the tradeoff for most people
		{
			require_code('polls');
			return poll_script(true,$param);
		}

		return do_template('BLOCK_MAIN_POLL_IFRAME',array('PARAM'=>strval($param),'ZONE'=>$zone));
	}

}


