<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		core_ocf
 */

class Hook_ocf
{

	/**
	 * Standard modular info function.
	 *
	 * @return ?array	Map of module info (NULL: module is disabled).
	 */
	function info()
	{
		if (get_forum_type()!='ocf') return NULL; else ocf_require_all_forum_stuff();

		require_lang('ocf');

		$info=array();
		$info['title']=do_lang_tempcode('SECTION_FORUMS');
		$info['description']=do_lang_tempcode('DESCRIPTION_CACHE_FORUMS');
		$info['type']='cache';

		return $info;
	}

	/**
	 * Standard modular run function.
	 *
	 * @return tempcode	Results
	 */
	function run()
	{
		if (get_forum_type()!='ocf') return new ocp_tempcode(); else ocf_require_all_forum_stuff();

		if (function_exists('set_time_limit')) @set_time_limit(0);

		// Forums
		require_code('ocf_posts_action2');
		$start=0;
		do
		{
			$forums=$GLOBALS['FORUM_DB']->query_select('f_forums',array('id'),NULL,'',100,$start);
			foreach ($forums as $forum)
			{
				ocf_force_update_forum_cacheing($forum['id']);
			}
			$start+=100;
		}
		while ($forums!=array());

		return new ocp_tempcode();
	}

}


