<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		downloads
 */

class Hook_config_default_download_gallery_root
{

	/**
	 * Gets the details relating to the config option.
	 *
	 * @return ?array		The details (NULL: disabled)
	 */
	function get_details()
	{
		return array(
			'human_name'=>'DOWNLOAD_GALLERY_ROOT',
			'the_type'=>'line',
			'the_page'=>'FEATURE',
			'section'=>'SECTION_DOWNLOADS',
			'explanation'=>'CONFIG_OPTION_download_gallery_root',
			'shared_hosting_restricted'=>'0',
			'c_data'=>'',

			'addon'=>'downloads',
		);
	}

	/**
	 * Gets the default value for the config option.
	 *
	 * @return ?string		The default value (NULL: option is disabled)
	 */
	function get_default()
	{
		$old=get_value('download_gallery_root');
		return is_null($old)?(addon_installed('galleries')?'root':NULL):$old;
	}

}


