<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		galleries
 */

class Hook_video_embed_youtube
{

	/**
	 * If we can handle this URL, get the render template and ID for it.
	 *
	 * @param  URLPATH		Video URL
	 * @return ?array			A pair: the template, and ID (NULL: no match)
	 */
	function get_template_name_and_id($url)
	{
		$matches=array();
		if ((preg_match('#^https?://www\.youtube\.com/watch\?v=([\w\-]+)#',$url,$matches)!=0) || (preg_match('#^https?://youtu\.be/([\w\-]+)#',$url,$matches)!=0))
		{
			$id=rawurldecode($matches[1]);
			return array('GALLERY_VIDEO_YOUTUBE',$id);
		}
		return NULL;
	}

	/**
	 * If we can handle this URL, get the thumbnail URL.
	 *
	 * @param  URLPATH		Video URL
	 * @return ?string		The thumbnail URL (NULL: no match).
	 */
	function get_video_thumbnail($src_url)
	{
		$matches=array();
		if ((preg_match('#^https?://www\.youtube\.com/watch\?v=([\w\-]+)#',$src_url,$matches)!=0) || (preg_match('#^https?://youtu\.be/([\w\-]+)#',$src_url,$matches)!=0))
		{
			return 'http://img.youtube.com/vi/'.rawurldecode($matches[1]).'/0.jpg';
		}
		return NULL;
	}

	/**
	 * Add a custom comcode field for this URL type.
	 */
	function add_custom_comcode_field()
	{
		$GLOBALS['SITE_DB']->query_insert('custom_comcode',array(
			'tag_tag'=>'youtube',
			'tag_title'=>lang_code_to_default_content('custom_comcode:YOUTUBE_TAG_TITLE'),
			'tag_description'=>lang_code_to_default_content('custom_comcode:YOUTUBE_TAG_DESCRIPTION'),
			'tag_replace'=>'{$SET,VIDEO,{$PREG_REPLACE,(https?://.*\?v=)?(https?://youtu.be/)?([\w\-]+)(.*)?,$\{3\},{$STRIP_TAGS,{content}}}}<object width="480" height="385"><param name="movie" value="http://www.youtube.com/v/{$GET*,VIDEO}?fs=1&amp;hl=en_US"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="http://www.youtube.com/v/{$GET*,VIDEO}?fs=1&amp;hl=en_US" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="480" height="385"></embed></object>',
			'tag_example'=>'[youtube]http://www.youtube.com/watch?v=ZDFFHaz9GsY[/youtube]',
			'tag_parameters'=>'',
			'tag_enabled'=>1,
			'tag_dangerous_tag'=>0,
			'tag_block_tag'=>1,
			'tag_textual_tag'=>0
		));
	}

}


